/***********************************************************************
*  Class Applett2
*  The applet for DiffEquation feature
*  Ehab W. Aziz Rez
***********************************************************************/

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.text.*;


public class PhasePlaneApplett extends Applet {

	private double x_low, x_high, y_low, y_high;//the values of the axes boundaries.
	private double divx, labx, divy,laby;//the amount to devide and label axes
	private String expression;

	/* GUI components */
	private TextField exprField, exprField2;
	private Label expressionEquals, expressionEquals2;

	private GraphArea3 ga;
	private Label xxx;
	private Label lowx, highx, lowy, highy, dividx, labelx, dividy, labely;
	private TextField xlow, xhigh, ylow, yhigh, dividX, labelX, dividY, labelY;
	private Button drawY1, clearY1, clearTrajectory, print, save;

public static void main(String args[]) {
		PhasePlaneApplett a = new PhasePlaneApplett();
		a.init();
		a.start();

		Frame f = new Frame("DIFF EQ, Phase Plane");
		f.add("Center", a);
		f.setSize(650,620);
		f.addWindowListener(
			new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			}
		);
//Menue Bar
		MenuBar myMenubar = new MenuBar();
		Menu fileMenu = new Menu("File");
        Menu editMenu = new Menu("Edit");

        MenuItem undo = new MenuItem("Undo");
		editMenu.add(undo);
		editMenu.addSeparator();
		MenuItem cut = new MenuItem("Cut");
		editMenu.add(cut);
		MenuItem copy = new MenuItem("Copy");
		editMenu.add(copy);
		MenuItem paste = new MenuItem("Paste");
		editMenu.add(paste);
		MenuItem clear = new MenuItem("Clear");
		editMenu.add(clear);
		editMenu.addSeparator();
		MenuItem selectAll = new MenuItem("Select All");
        editMenu.add(selectAll);

        myMenubar.add(fileMenu);
        myMenubar.add(editMenu);
        f.setMenuBar(myMenubar);

		f.setVisible(true);
	}


	public void init() {
		x_low = -10; x_high = 10; y_low = -10; y_high = 10; //the default values
		divx  =  1;  labx   = 2;  divy = 1  ; laby   = 2 ;
		//expression = "100* sin(x/5)* cos(x/50)";
		// add the interface components
		addGUIComponents1();
		}


/**
	 * Creates and adds the necessary GUI components.
	 */
	private void addGUIComponents1() {
		setBackground(Color.white);

		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridbag);
		c.fill = GridBagConstraints.BOTH;
		c.weightx = 1.0;

	//Panel1
		Panel panel1 = new Panel(gridbag);
	//the Expresion textfields
		expressionEquals = new Label("dx/dt =", Label.LEFT);
		c.gridy=1;
		panel1.add(expressionEquals, c);
		exprField = new TextField(expression,20);
		c.gridwidth = GridBagConstraints.REMAINDER;
		panel1.add(exprField, c);
		expressionEquals2 = new Label("dy/dt =", Label.LEFT);
		c.gridwidth = 1;
		c.gridy=2; panel1.add(expressionEquals2, c);
		exprField2 = new TextField(expression,20);
		c.gridwidth = GridBagConstraints.REMAINDER;
		panel1.add(exprField2, c);

	//The graph area


	    c.gridy=3; c.gridx=0;
    	c.insets = new Insets(5, 5, 5, 5);
	    c.anchor = GridBagConstraints.NORTH;
	    c.gridwidth=1;c.fill=GridBagConstraints.HORIZONTAL;
		xxx=new Label(" ", Label.CENTER);

        panel1.add(xxx, c);


	    c.gridy=3;
		c.insets = new Insets(0, 0, 2, 0);
		c.fill = GridBagConstraints.BOTH; c.weighty=1;
		ga = new GraphArea3(x_low,x_high, y_low, y_high);
		ga.setExpression(exprField.getText());
		ga.setaxesDevisionsAndLabels(divx,labx,divy,laby);
		c.gridwidth = GridBagConstraints.REMAINDER;   panel1.add(ga,c);


	//the boundary buttons
	    c.weighty = 1;
	    c.gridy=4;

		lowx  = new Label("Low x", Label.RIGHT);
		c.gridwidth = 1; c.gridx=0;panel1.add(lowx, c);
		//
		xlow = new TextField("" + x_low,3);
		c.gridwidth = 1; c.gridx=1;panel1.add(xlow, c);
		//
		highx = new Label("High x", Label.RIGHT);
		c.gridwidth = 1; c.gridx=2;panel1.add(highx, c);
		//
		xhigh = new TextField("" + x_high,3);
		c.gridwidth = 1; c.gridx=3;panel1.add(xhigh, c);
		//
		lowy  = new Label("Low y", Label.RIGHT);
		c.gridwidth = 1; c.gridx=4;panel1.add(lowy, c);
		//
		ylow = new TextField("" + y_low,3);
		c.gridwidth = 1; c.gridx=5;panel1.add(ylow, c);
		//
		highy = new Label("High y", Label.RIGHT);
		c.gridx=6;//c.gridwidth = GridBagConstraints.RELATIVE;
		panel1.add(highy, c);
		//
		yhigh = new TextField("" + y_high,3);
		c.gridx=7;//c.gridwidth = GridBagConstraints.REMAINDER;
		panel1.add(yhigh,c);

	//X and Y divisions and labeing
	    c.gridy=5;
		dividx  = new Label("Divide X into", Label.RIGHT);
		c.gridwidth = 1; c.gridx=0;panel1.add(dividx, c);
		//
		dividX = new TextField(""+ divx ,3);
		c.gridwidth = 1; c.gridx=1;panel1.add(dividX, c);
		//
		labelx = new Label("Label X every", Label.RIGHT);
		c.gridwidth = 1; c.gridx=2;panel1.add(labelx, c);
		//
		labelX = new TextField("" + labx ,3);
		c.gridwidth = 1; c.gridx=3;panel1.add(labelX,c);
		//
		dividy  = new Label("Divide Y into", Label.RIGHT);
		c.gridwidth = 1; c.gridx=4;panel1.add(dividy, c);
		//
		dividY = new TextField("" + divy,3);
		c.gridwidth = 1; c.gridx=5;panel1.add(dividY, c);
		//
		labely = new Label("Label Y every", Label.RIGHT);
		c.gridx=6;//c.gridwidth = GridBagConstraints.RELATIVE;
		panel1.add(labely, c);
		//
		labelY = new TextField("" + laby ,3);
		c.gridx=7;//c.gridwidth = GridBagConstraints.REMAINDER;;
		panel1.add(labelY,c);
	//Buttons draw, clear, clearTrajectory
	    c.gridy=6;
		drawY1 = new Button("Draw Slope Field");
		clearY1 = new Button("Clear Slope Field");
		clearTrajectory = new Button("Clear Trajectory");
		c.gridwidth = 2; c.weightx = 0.5;
		c.insets = new Insets(0,0,2,30);
		c.fill=GridBagConstraints.HORIZONTAL;
		c.gridx=0;panel1.add(drawY1, c);
		c.gridx=2;panel1.add(clearY1, c);
		c.gridx=4;panel1.add(clearTrajectory, c);
		c.insets = new Insets(0,0,2,0);

	    c.gridy=6;

	//Button
		print = new Button("Print");
		c.gridwidth=1;
	    c.gridx=6;panel1.add(print, c);
	//Button
		save = new Button("Save");
		//c.gridwidth = GridBagConstraints.REMAINDER;
		c.gridx=7;panel1.add(save, c);


	//adding panel1

		c.fill=GridBagConstraints.NONE;
		c.gridx=0; c.gridy=0; c.gridwidth =8; c.weighty=0; add(panel1,c);

/** Adding Listeners     */

		drawY1.addActionListener(
							         new ActionListener(){
										 public void actionPerformed(ActionEvent evt) {
											 drawY1ButtonPressed();
									     }
									 }
		);

		clearY1.addActionListener(
							         new ActionListener(){
										 public void actionPerformed(ActionEvent evt) {
											 clearY1ButtonPressed();
									     }
									 }
        );

        clearTrajectory.addActionListener(
									new ActionListener(){
										public void actionPerformed(ActionEvent evt) {
											ctPressed();
										}
									}
								);
        ga.addMouseListener(
									new MouseListener(){
										public void mouseClicked(MouseEvent evt) {
											mClicked(evt);
										}
										public void mouseExited(MouseEvent evt) {}
										public void mousePressed(MouseEvent evt) {}
										public void mouseReleased(MouseEvent evt) {}

										public void mouseEntered(MouseEvent evt) {}


									}
		);
		ga.addMouseMotionListener(
									new MouseMotionListener(){
										public void mouseDragged(MouseEvent evt) {}
										public void mouseMoved(MouseEvent evt) {
											double x = evt.getX();x=ga.plottedX(x);
	                                        double y = evt.getY();y=ga.plottedY(y);
	                                        String fmt = "0.00#";
											DecimalFormat df = new DecimalFormat(fmt);
											String xxxx = df.format(x);
											String yyyy = df.format(y);
										    String sss = "(".concat(xxxx).concat(",").
										                 concat(yyyy).concat(")");
	                                        xxx.setText(sss);

	                                        ga.setMP(new Point2D.Double(x, y));
	                                        //ga.setPositionDisplay(true);


										}

									}
		);

}//addGUICmponents()


        private double evaluateExpression(double x)
        {
			Equation eq = new Equation(exprField.getText());
            double res = eq.Evaluate("x", x);
            return res;
        }

		private double evaluateIntegration(double from, double to, double step)
		{
			double value =0.0; //integration value
			double val1 = evaluateExpression(from);
			double currentx= from; //current x value
			for(double k=from+step; k<=to; k+=step)
			{
				currentx = k;
				double val2 = evaluateExpression(k);
				double tobeadded =(0.5)*(val1+val2)*(step);
				value+=tobeadded;
				val1=val2;
			}
			if (currentx<to)
			{
				double val2 = evaluateExpression(to);
				double tobeadded =(0.5)*(val1+val2)*(step);
				value+=tobeadded;
			}

			return value;

		}


		private void drawY1ButtonPressed(){
			ga.setExpression(exprField.getText());
			ga.setExpression2(exprField2.getText());

			double xl = Double.valueOf(xlow.getText()).doubleValue();
			double xh = Double.valueOf(xhigh.getText()).doubleValue();
			double yl = Double.valueOf(ylow.getText()).doubleValue();
			double yh = Double.valueOf(yhigh.getText()).doubleValue();
			ga.setBoundaries(xl,xh,yl,yh);


			double xd = Double.valueOf(dividX.getText()).doubleValue();
			double xlab = Double.valueOf(labelX.getText()).doubleValue();
			double yd = Double.valueOf(dividY.getText()).doubleValue();
			double ylab = Double.valueOf(labelY.getText()).doubleValue();
			ga.setaxesDevisionsAndLabels(xd,xlab,yd,ylab);

			ga.setSlopeFieldDrawer(true);

			ga.draw();
			//ga.setFunctionDrawer(false);
		}


		private void clearY1ButtonPressed(){
			ga.setSlopeFieldDrawer(false);

			ga.repaint();
		}

		private void ctPressed(){
			ga.setTrajectoryDrawer(false);
			ga.repaint();
		}

		private void mClicked(MouseEvent evt)
		{
			double x = evt.getX(), y = evt.getY();
			Point2D.Double po = new Point2D.Double(x,y);
			ga.setPoint(po);
			ga.setTrajectoryDrawer(true);
			ga.draw();
		}





}//class